\ EDITFORMFUNCTIONS.FRM
anew EDITFORMFUNCTIONS.FRM
Decimal
\- textbox needs excontrols.f

\- Control# 0 value Control#

MultiLineTextBox MTxtClassInitCode
Label lblFormCloseCode
MultiLineTextBox MTxtFormCloseCode
Label lblFormDoneCode
MultiLineTextBox MTxtFormDoneCode
PushButton btnFuncEdSave
PushButton btnFuncEdCancel
MultiLineTextBox MTxtFormNeedsCode
Label lblFormNeedsCode

:Object frmFuncEdit                <Super Child-Window

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 

\ Font setting definitions

Label lblClassInitCode

 \ Not executable: lblClassInitCode  ( -- )  noop ;


: frmDefaultCommand	( id obj-addr -- )
                swap
                case
                endcase   drop ;

:M ClassInit:   ( -- )
                ClassInit: super
                +dialoglist  \ allow handling of dialog messages
                366  to id     \ set child id, changeable
                ;M

:M Display:     ( -- ) \ unhide the child window
                SW_SHOWNORMAL Show: self ;M

:M Hide:        ( -- )   \ hide the...aughhh but you know that!
                SW_HIDE Show: self ;M

:M WindowTitle: ( -- ztitle )
                z" Edit Function     2/26/2012  2:21:31 AM"
                ;M

:M StartSize:   ( -- width height )
                358 302 
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor

                \ FormInit-Functions:
                

                self Start: lblClassInitCode
                9 70 102 11 Move: lblClassInitCode
                Handle: Winfont SetFont: lblClassInitCode
                s" Form-Init-Function:" SetText: lblClassInitCode

                self Start: MTxtClassInitCode
                10 88 340 40 Move: MTxtClassInitCode
                Handle: Winfont SetFont: MTxtClassInitCode

                self Start: lblFormCloseCode
                9 132 102 11 Move: lblFormCloseCode
                Handle: Winfont SetFont: lblFormCloseCode
                s" Form-Close-Function:" SetText: lblFormCloseCode

                self Start: MTxtFormCloseCode
                10 149 340 40 Move: MTxtFormCloseCode
                Handle: Winfont SetFont: MTxtFormCloseCode

                self Start: lblFormDoneCode
                9 196 102 11 Move: lblFormDoneCode
                Handle: Winfont SetFont: lblFormDoneCode
                s" Form-Done-Function:" SetText: lblFormDoneCode

                self Start: MTxtFormDoneCode
                10 211 340 40 Move: MTxtFormDoneCode
                Handle: Winfont SetFont: MTxtFormDoneCode

                self Start: btnFuncEdSave
                11 260 89 30 Move: btnFuncEdSave
                Handle: Winfont SetFont: btnFuncEdSave                s" Save Words to Execute with Form" ToolString: btnFuncEdSave

                s" &Apply" SetText: btnFuncEdSave

                self Start: btnFuncEdCancel
                260 259 90 32 Move: btnFuncEdCancel
                Handle: Winfont SetFont: btnFuncEdCancel                s" Close without Saving Form-Words" ToolString: btnFuncEdCancel

                s" &Close" SetText: btnFuncEdCancel

                self Start: MTxtFormNeedsCode
                9 25 340 40 Move: MTxtFormNeedsCode
                Handle: Winfont SetFont: MTxtFormNeedsCode

                self Start: lblFormNeedsCode
                9 8 102 11 Move: lblFormNeedsCode
                Handle: Winfont SetFont: lblFormNeedsCode
                s" Form needs:" SetText: lblFormNeedsCode

                ['] frmDefaultCommand SetCommand: self


                \ FormInitialized-Functions:
                
                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont

                \ FormDone-Function:
                
                On_Done: super
                ;M

;Object

: Start  ( -- )
                start: frmFuncEdit
                 ;

' Start alias frmFuncEdit-Start

: Stop  ( -- )
                close: frmFuncEdit
                 ;

' Stop alias frmFuncEdit-Stop



 \ Not executable: noop SetFunc: MTxtClassInitCode

 \ Not executable: noop SetFunc: lblFormCloseCode

 \ Not executable: noop SetFunc: MTxtFormCloseCode

 \ Not executable: noop SetFunc: lblFormDoneCode

 \ Not executable: noop SetFunc: MTxtFormDoneCode

' SaveFormWords SetFunc: btnFuncEdSave

' CloseEditFormCode SetFunc: btnFuncEdCancel

 \ Not executable: noop SetFunc: MTxtFormNeedsCode

 \ Not executable: noop SetFunc: lblFormNeedsCode

