\ EDITFUNCTION.FRM	Form to add Functions to Control	DB 2008
\- textbox needs excontrols.f

TextBox txtEdFunction
MultiLineTextBox MtxtFunction
MultiLineTextBox MTxtRequirements
PushButton btnFuncEdSave
PushButton btnFuncEdCancel

: EditFunctionTitle$ ( -- addr cnt )
                s" Edit Function " new$ dup>r place
                GetName: ActiveCtrl r@ +place
                r> count 
;

:Object frmFuncEdit                <Super DialogWindow

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 
150 175  2value XYPos  \ save screen location of form
\ Font setting definitions

Font Courier-font
: Set-Courier-font ( -- )
                -15          Height: Courier-font
                0             Width: Courier-font
                0        Escapement: Courier-font
                0       Orientation: Courier-font
                400          Weight: Courier-font
                0           CharSet: Courier-font
                3      OutPrecision: Courier-font
                2     ClipPrecision: Courier-font
                1           Quality: Courier-font
                49   PitchAndFamily: Courier-font
                s" Courier New" SetFacename: Courier-font ;

Label lblFuncName
Label lblRequirements

:M ClassInit:   ( -- )
                ClassInit: super
                \ Insert your code here
                ;M

:M WindowStyle:  ( -- style )
                WS_POPUPWINDOW WS_DLGFRAME or 
                ;M

\ if this form is a modal form a non-zero parent must be set
:M ParentWindow:  ( -- hwndparent | 0 if no parent )
                hWndParent
                ;M

:M SetParentWindow:  ( hwndparent -- ) \ set owner window
                to hWndParent
                ;M

:M WindowTitle: ( -- title )
                EditFunctionTitle$ asciiz ;M

:M StartSize:   ( -- width height )
                358 302 
                ;M

:M StartPos:    ( -- x y )
                XYPos
                ;M

:M Close:        ( -- )
                \ Insert your code here
                Close: super
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor


                self Start: lblFuncName
                10 133 44 14 Move: lblFuncName
                Handle: Winfont SetFont: lblFuncName
                s" Function:" SetText: lblFuncName

                self Start: txtEdFunction
                60 131 290 20 Move: txtEdFunction
                Handle: Winfont SetFont: txtEdFunction

                self Start: MtxtFunction
                10 160 340 90 Move: MtxtFunction
                Set-Courier-font
                Create: Courier-font
                Handle: Courier-font SetFont: MtxtFunction

                self Start: lblRequirements
                9 10 93 11 Move: lblRequirements
                Handle: Winfont SetFont: lblRequirements
                s" Requirements:" SetText: lblRequirements

                self Start: MTxtRequirements
                9 29 341 92 Move: MTxtRequirements
                Set-Courier-font
                Handle: Courier-font SetFont: MTxtRequirements

                self Start: btnFuncEdSave
                11 260 89 30 Move: btnFuncEdSave
                Handle: Winfont SetFont: btnFuncEdSave
                s" &Apply" SetText: btnFuncEdSave

                self Start: btnFuncEdCancel
                260 259 90 32 Move: btnFuncEdCancel
                Handle: Winfont SetFont: btnFuncEdCancel
                s" &Close" SetText: btnFuncEdCancel

                ParentWindow: self   \ if this is a modal form disable parent
                if   0 ParentWindow: self Call EnableWindow drop then
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont
                Delete: Courier-font
                originx originy 2to XYPos
                ParentWindow: self   \ if modal form re-enable parent
                if   1 ParentWindow: self Call EnableWindow drop
                     \ reset focus to parent if we have one
                     ParentWindow: self Call SetFocus drop
                then
                \ Insert your code here
                On_Done: super
                ;M

;Object

 \ Not executable noop SetFunc: txtEdFunction

 \ Not executable noop SetFunc: MtxtFunction

 \ Not executable noop SetFunc: MTxtRequirements

 \ ' noop SetFunc: btnFuncEdSave \ defined in FORMPROPERTY.F

: CloseEditFunction  ( -- ) 
Close:  frmFuncEdit
; 

' CloseEditFunction SetFunc: btnFuncEdCancel

