\ PREFERENCES.FRM
anew PREFERENCES.FRM
Decimal
\- textbox needs excontrols.f

\- Control# 0 value Control#

CheckBox chkFlatToolBar
CheckBox chkButtonText
CheckBox chkShowMonitor
CheckBox chkShowReleaseNotes
CheckBox chkConsole
GroupRadioButton radAlignTop
RadioButton radAlignBottom
RadioButton radAlignLeft
RadioButton radAlignRight
CheckBox chkZooming
CheckBox chkCopyCodeClp
PushButton btnOk
PushButton btnCancel

:Object frmPreferences                <Super DialogWindow

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 
150 175  2value XYPos  \ save screen location of form

\ Font setting definitions

GroupBox grpAlign
GroupBox grpOther
GroupBox grpToolBar
GroupBox grpCompilerSettings

 \ Not executable: grpAlign  ( -- )  noop ;

 \ Not executable: grpOther  ( -- )  noop ;

 \ Not executable: grpToolBar  ( -- )  noop ;

 \ Not executable: grpCompilerSettings  ( -- )  noop ;


: frmDefaultCommand	( id obj-addr -- )
                swap
                case
                endcase   drop ;

:M ClassInit:   ( -- )
                ClassInit: super
                ;M

:M WindowStyle:  ( -- style )
                WS_POPUPWINDOW WS_DLGFRAME or 
                ;M

\ if this form is a modal form a non-zero parent must be set
:M ParentWindow:  ( -- hwndparent | 0 if no parent )
                hWndParent
                ;M

:M SetParentWindow:  ( hwndparent -- ) \ set owner window
                to hWndParent
                ;M

:M WindowTitle: ( -- ztitle )
                z" Preferences"
                ;M

:M StartSize:   ( -- width height )
                302 219 
                ;M

:M StartPos:    ( -- x y )
                XYPos
                ;M

:M Close:        ( -- )
                \ FormClose-Function:
                
                Close: super
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor

                \ FormInit-Functions:
                

                self Start: grpAlign
                172 6 109 100 Move: grpAlign
                Handle: Winfont SetFont: grpAlign
                s" Rebar Position" SetText: grpAlign

                self Start: grpOther
                11 80 137 102 Move: grpOther
                Handle: Winfont SetFont: grpOther
                s" Options" SetText: grpOther

                self Start: grpToolBar
                11 6 140 65 Move: grpToolBar
                Handle: Winfont SetFont: grpToolBar
                s" Toolbar" SetText: grpToolBar

                self Start: grpCompilerSettings
                172 117 109 65 Move: grpCompilerSettings
                Handle: Winfont SetFont: grpCompilerSettings
                s" Compiler Settings" SetText: grpCompilerSettings

                self Start: chkFlatToolBar
                18 21 79 18 Move: chkFlatToolBar
                Handle: Winfont SetFont: chkFlatToolBar
                s" Flat Style" SetText: chkFlatToolBar

                self Start: chkButtonText
                18 43 122 18 Move: chkButtonText
                Handle: Winfont SetFont: chkButtonText
                s" Show Text in Buttons" SetText: chkButtonText

                self Start: chkShowMonitor
                18 101 89 18 Move: chkShowMonitor
                Handle: Winfont SetFont: chkShowMonitor
                s" Show Monitor" SetText: chkShowMonitor

                self Start: chkShowReleaseNotes
                18 122 120 25 Move: chkShowReleaseNotes
                Handle: Winfont SetFont: chkShowReleaseNotes
                s" Show Release Notes" SetText: chkShowReleaseNotes

                self Start: chkConsole
                19 149 100 25 Move: chkConsole
                Handle: Winfont SetFont: chkConsole
                s" Show Console" SetText: chkConsole

                self Start: radAlignTop
                180 21 61 19 Move: radAlignTop
                Handle: Winfont SetFont: radAlignTop
                s" Top" SetText: radAlignTop

                self Start: radAlignBottom
                180 42 61 19 Move: radAlignBottom
                Handle: Winfont SetFont: radAlignBottom
                s" Bottom" SetText: radAlignBottom

                self Start: radAlignLeft
                180 63 61 19 Move: radAlignLeft
                Handle: Winfont SetFont: radAlignLeft
                s" Left" SetText: radAlignLeft

                self Start: radAlignRight
                180 84 61 19 Move: radAlignRight
                Handle: Winfont SetFont: radAlignRight
                s" Right" SetText: radAlignRight

                self Start: chkZooming
                181 137 89 18 Move: chkZooming
                Handle: Winfont SetFont: chkZooming
                s" Zooming" SetText: chkZooming

                self Start: chkCopyCodeClp
                181 158 89 18 Move: chkCopyCodeClp
                Handle: Winfont SetFont: chkCopyCodeClp
                s" Copy Code Clp." SetText: chkCopyCodeClp

                self Start: btnOk
                162 190 58 22 Move: btnOk
                WS_GROUP +Style: btnOk
                Handle: Winfont SetFont: btnOk
                s" &Ok" SetText: btnOk

                self Start: btnCancel
                232 190 58 22 Move: btnCancel
                Handle: Winfont SetFont: btnCancel
                s" &Cancel" SetText: btnCancel

                ParentWindow: self   \ if this is a modal form disable parent
                if   0 ParentWindow: self Call EnableWindow drop then
                ['] frmDefaultCommand SetCommand: self

                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont

                originx originy 2to XYPos
                ParentWindow: self   \ if modal form re-enable parent
                if   1 ParentWindow: self Call EnableWindow drop
                     \ reset focus to parent if we have one
                     ParentWindow: self Call SetFocus drop
                then
                \ FormDone-Function:
                
                On_Done: super
                ;M

;Object

: Start  ( -- )
                start: frmPreferences
                 ;

' Start alias frmPreferences-Start

: Stop  ( -- )
                close: frmPreferences
                 ;

' Stop alias frmPreferences-Stop



 \ Not executable: noop SetFunc: chkFlatToolBar

 \ Not executable: noop SetFunc: chkButtonText

 \ Not executable: noop SetFunc: chkShowMonitor

 \ Not executable: noop SetFunc: chkShowReleaseNotes

 \ Not executable: noop SetFunc: chkConsole

 \ Not executable: SetControl#0 SetFunc: radAlignTop

 \ Not executable: noop SetFunc: radAlignBottom

 \ Not executable: noop SetFunc: radAlignLeft

 \ Not executable: noop SetFunc: radAlignRight

 \ Not executable: noop SetFunc: chkZooming

 \ Not executable: noop SetFunc: chkCopyCodeClp

: SetControl#0  ( -- ) 
0 to Control#

; 
' SetControl#0 SetFunc: btnOk

' noop SetFunc: btnCancel

