\ CREATEMENUFORMII.FRM
anew CREATEMENUFORMII.FRM
Decimal
\- textbox needs excontrols.f

\- Control# 0 value Control#


:Object frmDefineMenu                <Super DialogWindow

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 
270 170  2value XYPos  \ save screen location of form

\ Font setting definitions

GroupBox grpFunction
GroupBox grpAdd
Label lblMenu
\ Coordinates and dimensions for tvMenuTree
8  value tvMenuTreeX
28  value tvMenuTreeY
373  value tvMenuTreeW
115  value tvMenuTreeH
Label lblMenuText
TextBox txtMenutext
PushButton btnClear
Label lblName
TextBox txtName
PushButton btnPopup
PushButton btnSubMenu
PushButton btnMenuItem
PushButton btnSeparator
PushButton btnNew
PushButton btnDelete
PushButton btnRename
PushButton btnEdit
PushButton btnClipboard
PushButton btnSave
PushButton btnLoad
PushButton btnTest
PushButton btnClose
PushButton btnMenuHelp   \  added DB 2012-0224
TextBox txtMenuFunction  \  added DB 2012-0224 
Label lblMenuFunction    \  added DB 2012-0224

 \ Not executable: grpFunction  ( -- )  noop ;

 \ Not executable: grpAdd  ( -- )  noop ;

 \ Not executable: lblMenu  ( -- )  noop ;

 \ Not executable: tvMenuTree  ( -- )  noop ;

 \ Not executable: lblMenuText  ( -- )  noop ;

 \ Not executable: txtMenutext  ( -- )  noop ;

: On_btnClear  ( -- )  noop ;

 \ Not executable: lblName  ( -- )  noop ;

 \ Not executable: txtName  ( -- )  noop ;

: On_btnPopup  ( -- )  noop ;

: On_btnSubMenu  ( -- )  noop ;

: On_btnMenuItem  ( -- )  noop ;

: On_btnSeparator  ( -- )  noop ;

: On_btnNew  ( -- )  noop ;

: On_btnDelete  ( -- )  noop ;

: On_btnRename  ( -- )  noop ;

: On_btnEdit  ( -- )  noop ;

: On_btnClipboard  ( -- )  noop ;

: On_btnSave  ( -- )  noop ;

: On_btnLoad  ( -- )  noop ;

: On_btnTest  ( -- )  noop ;

: On_btnClose  ( -- )  noop ;

: HelpDefineMenu  ( -- ) 
s" doc\ForthForm\FF-Define a Menu.htm"
+help$ 2dup c! 1+ swap cmove   ok
doFormHelp +help$ off
; 
: On_btnMenuHelp  ( -- ) HelpDefineMenu ;

 \ Not executable: txtMenuFunction  ( -- )  noop ;

 \ Not executable: lblMenuFunction  ( -- )  noop ;


: frmDefaultCommand	( id obj-addr -- )
                swap
                case
                    GetID: btnClear  of On_btnClear endof
                    GetID: btnPopup  of On_btnPopup endof
                    GetID: btnSubMenu  of On_btnSubMenu endof
                    GetID: btnMenuItem  of On_btnMenuItem endof
                    GetID: btnSeparator  of On_btnSeparator endof
                    GetID: btnNew  of On_btnNew endof
                    GetID: btnDelete  of On_btnDelete endof
                    GetID: btnRename  of On_btnRename endof
                    GetID: btnEdit  of On_btnEdit endof
                    GetID: btnClipboard  of On_btnClipboard endof
                    GetID: btnSave  of On_btnSave endof
                    GetID: btnLoad  of On_btnLoad endof
                    GetID: btnTest  of On_btnTest endof
                    GetID: btnClose  of On_btnClose endof
                    GetID: btnMenuHelp  of On_btnMenuHelp endof
                endcase   drop ;

:M ClassInit:   ( -- )
                ClassInit: super
                ;M

:M WindowStyle:  ( -- style )
                WS_POPUPWINDOW WS_DLGFRAME or 
                ;M

\ if this form is a modal form a non-zero parent must be set
:M ParentWindow:  ( -- hwndparent | 0 if no parent )
                hWndParent
                ;M

:M SetParentWindow:  ( hwndparent -- ) \ set owner window
                to hWndParent
                ;M

:M WindowTitle: ( -- ztitle )
                z" Define Menu     2/24/2012  6:59:11 PM"
                ;M

:M StartSize:   ( -- width height )
                389 289 
                ;M

:M StartPos:    ( -- x y )
                XYPos
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor

                \ FormInit-Functions:
                

                self Start: grpFunction
                119 175 75 87 Move: grpFunction
                Handle: Winfont SetFont: grpFunction
                s" Options" SetText: grpFunction

                self Start: grpAdd
                8 175 95 114 Move: grpAdd
                Handle: Winfont SetFont: grpAdd
                s" Add" SetText: grpAdd

                self Start: lblMenu
                8 8 41 17 Move: lblMenu
                Handle: Winfont SetFont: lblMenu
                s" Menu:" SetText: lblMenu

                self Start: lblMenuText
                11 150 50 16 Move: lblMenuText
                Handle: Winfont SetFont: lblMenuText
                s" MenuText:" SetText: lblMenuText

                self Start: txtMenutext
                65 150 106 17 Move: txtMenutext
                Handle: Winfont SetFont: txtMenutext

                self Start: btnClear
                178 150 25 17 Move: btnClear
                Handle: Winfont SetFont: btnClear
                s" &C" SetText: btnClear

                self Start: lblName
                205 150 35 17 Move: lblName
                Handle: Winfont SetFont: lblName
                SS_RIGHT +Style: lblName
                s" Name:" SetText: lblName

                self Start: txtName
                243 150 137 17 Move: txtName
                Handle: Winfont SetFont: txtName

                self Start: btnPopup
                10 190 86 21 Move: btnPopup
                Handle: Winfont SetFont: btnPopup
                s" &Popup" SetText: btnPopup

                self Start: btnSubMenu
                10 213 86 21 Move: btnSubMenu
                Handle: Winfont SetFont: btnSubMenu
                s" &Submenu" SetText: btnSubMenu

                self Start: btnMenuItem
                10 236 86 21 Move: btnMenuItem
                Handle: Winfont SetFont: btnMenuItem
                s" &MenuItem" SetText: btnMenuItem

                self Start: btnSeparator
                10 259 86 23 Move: btnSeparator
                Handle: Winfont SetFont: btnSeparator
                s" Men&uSeparator" SetText: btnSeparator

                self Start: btnNew
                127 190 60 21 Move: btnNew
                Handle: Winfont SetFont: btnNew
                s" &New Menu" SetText: btnNew

                self Start: btnDelete
                127 213 60 21 Move: btnDelete
                Handle: Winfont SetFont: btnDelete
                s" &Delete" SetText: btnDelete

                self Start: btnRename
                127 236 60 21 Move: btnRename
                Handle: Winfont SetFont: btnRename
                s" &Rename" SetText: btnRename

                self Start: btnEdit
                215 190 69 21 Move: btnEdit
                Handle: Winfont SetFont: btnEdit
                s" &Edit" SetText: btnEdit

                self Start: btnClipboard
                286 190 69 21 Move: btnClipboard
                Handle: Winfont SetFont: btnClipboard
                s" Cl&ipboard" SetText: btnClipboard

                self Start: btnSave
                215 213 69 21 Move: btnSave
                Handle: Winfont SetFont: btnSave
                s" Sa&ve" SetText: btnSave

                self Start: btnLoad
                286 213 69 21 Move: btnLoad
                Handle: Winfont SetFont: btnLoad
                s" &Load" SetText: btnLoad

                self Start: btnTest
                215 236 69 21 Move: btnTest
                Handle: Winfont SetFont: btnTest
                s" &Test" SetText: btnTest

                self Start: btnClose
                286 236 69 21 Move: btnClose
                Handle: Winfont SetFont: btnClose
                s" C&lose" SetText: btnClose

                self Start: btnMenuHelp
                286 259 69 21 Move: btnMenuHelp
                Handle: Winfont SetFont: btnMenuHelp
                s" Help" SetText: btnMenuHelp

                self Start: txtMenuFunction
                243 170 137 17 Move: txtMenuFunction
                Handle: Winfont SetFont: txtMenuFunction

                self Start: lblMenuFunction
                195 172 45 16 Move: lblMenuFunction
                Handle: Winfont SetFont: lblMenuFunction
                SS_RIGHT +Style: lblMenuFunction
                s" Function:" SetText: lblMenuFunction

                ['] frmDefaultCommand SetCommand: self


                \ FormInitialized-Functions:
                
                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont

                originx originy 2to XYPos
                \ FormDone-Function:
                
                On_Done: super
                ;M

;Object

: Start  ( -- )
                start: frmDefineMenu
                 ;

' Start alias frmDefineMenu-Start

: Stop  ( -- )
                close: frmDefineMenu
                 ;

' Stop alias frmDefineMenu-Stop



