\ FORMPROPERTY.FRM
anew FORMPROPERTY.FRM
Decimal
\- textbox needs excontrols.f
\- usebitmap needs bitmap.f

\- Control# 0 value Control#

CheckBox chkMenuBar
PushButton BtnEditFormCode
PushButton btnMenuBarFile
TextBox TxtMenuBarFile

:Object frmEditFormProperties                <Super DialogWindow

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 

\ Font setting definitions

GroupBox grpOptions
GroupBox grpSuperClass
Label lblName
TextBox TxtName
Label lblTitle
TextBox TxtTitle
Label lblXPos
SpinnerControl spnXpos
Label lblYpos
SpinnerControl spnYpos
Label lblWidth
SpinnerControl spnWidth
Label lblHeight
SpinnerControl spnHeight
CheckBox chkStatusBar
CheckBox chkModal
CheckBox chkSave
GroupRadioButton radDialogWindow
RadioButton radChildWindow
CheckBox chkChildState
RadioButton radMdiDialogWindow

 \ Not executable: grpOptions  ( -- )  noop ;

 \ Not executable: grpSuperClass  ( -- )  noop ;

 \ Not executable: lblName  ( -- )  noop ;

 \ Not executable: TxtName  ( -- )  noop ;

 \ Not executable: lblTitle  ( -- )  noop ;

 \ Not executable: TxtTitle  ( -- )  noop ;

 \ Not executable: lblXPos  ( -- )  noop ;

 \ Not executable: spnXpos  ( -- )  noop ;

 \ Not executable: lblYpos  ( -- )  noop ;

 \ Not executable: spnYpos  ( -- )  noop ;

 \ Not executable: lblWidth  ( -- )  noop ;

 \ Not executable: spnWidth  ( -- )  noop ;

 \ Not executable: lblHeight  ( -- )  noop ;

 \ Not executable: spnHeight  ( -- )  noop ;

 \ Not executable: chkStatusBar  ( -- )  noop ;

 \ Not executable: chkModal  ( -- ) SetControl#0 ;

 \ Not executable: chkSave  ( -- )  noop ;

 \ Not executable: radDialogWindow  ( -- ) SetControl#0 ;

 \ Not executable: radChildWindow  ( -- )  noop ;

 \ Not executable: chkChildState  ( -- )  noop ;

 \ Not executable: radMdiDialogWindow  ( -- )  noop ;


: frmDefaultCommand	( id obj-addr -- )
                swap
                case
                endcase   drop ;

:M ClassInit:   ( -- )
                ClassInit: super
                ;M

:M WindowStyle:  ( -- style )
                WindowStyle: SUPER 
                ;M

:M WindowTitle: ( -- ztitle )
                z" Edit Form Properties     4/14/2012  5:57:38 PM"
                ;M

:M StartSize:   ( -- width height )
                237 268 
                ;M

:M StartPos:    ( -- x y )
                265  220
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor

                \ FormInit-Functions:
                

                self Start: grpOptions
                16 93 216 76 Move: grpOptions
                Handle: Winfont SetFont: grpOptions
                s" Options" SetText: grpOptions

                self Start: grpSuperClass
                15 169 217 82 Move: grpSuperClass
                Handle: Winfont SetFont: grpSuperClass
                s" Compile As" SetText: grpSuperClass

                self Start: lblName
                5 6 52 17 Move: lblName
                Handle: Winfont SetFont: lblName
                SS_RIGHT +Style: lblName
                s" Name:" SetText: lblName

                self Start: TxtName
                61 6 163 16 Move: TxtName
                Handle: Winfont SetFont: TxtName

                self Start: lblTitle
                5 24 52 17 Move: lblTitle
                Handle: Winfont SetFont: lblTitle
                SS_RIGHT +Style: lblTitle
                s" Title" SetText: lblTitle

                self Start: TxtTitle
                61 25 163 16 Move: TxtTitle
                Handle: Winfont SetFont: TxtTitle

                self Start: lblXPos
                24 47 33 17 Move: lblXPos
                Handle: Winfont SetFont: lblXPos
                SS_RIGHT +Style: lblXPos
                s" XPos:" SetText: lblXPos

                self Start: spnXpos
                61 44 46 21 Move: spnXpos
                Handle: Winfont SetFont: spnXpos
                \ set default values, easily changed 
                0 1024 SetRange: spnXpos
                0 SetValue: spnXpos

                self Start: lblYpos
                118 47 31 17 Move: lblYpos
                Handle: Winfont SetFont: lblYpos
                SS_RIGHT +Style: lblYpos
                s" YPos:" SetText: lblYpos

                self Start: spnYpos
                155 44 46 21 Move: spnYpos
                Handle: Winfont SetFont: spnYpos
                \ set default values, easily changed 
                0 1024 SetRange: spnYpos
                0 SetValue: spnYpos

                self Start: lblWidth
                24 74 36 20 Move: lblWidth
                Handle: Winfont SetFont: lblWidth
                SS_RIGHT +Style: lblWidth
                s" Width:" SetText: lblWidth

                self Start: spnWidth
                61 72 46 21 Move: spnWidth
                Handle: Winfont SetFont: spnWidth
                \ set default values, easily changed 
                0 1023 SetRange: spnWidth
                0 SetValue: spnWidth

                self Start: lblHeight
                118 74 34 17 Move: lblHeight
                Handle: Winfont SetFont: lblHeight
                s" Height:" SetText: lblHeight

                self Start: spnHeight
                155 72 46 21 Move: spnHeight
                Handle: Winfont SetFont: spnHeight
                \ set default values, easily changed 
                0 1024 SetRange: spnHeight
                0 SetValue: spnHeight

                self Start: chkMenuBar
                25 107 70 17 Move: chkMenuBar
                Handle: Winfont SetFont: chkMenuBar
                s" Menu Bar" SetText: chkMenuBar

                self Start: chkStatusBar
                148 125 78 17 Move: chkStatusBar
                Handle: Winfont SetFont: chkStatusBar
                s" Status Bar" SetText: chkStatusBar

                self Start: chkModal
                25 125 84 17 Move: chkModal
                WS_GROUP +Style: chkModal
                Handle: Winfont SetFont: chkModal
                s" Modal Form" SetText: chkModal

                self Start: chkSave
                25 144 121 14 Move: chkSave
                Handle: Winfont SetFont: chkSave
                s" Save screen location" SetText: chkSave

                self Start: radDialogWindow
                25 183 115 20 Move: radDialogWindow
                Handle: Winfont SetFont: radDialogWindow
                s" Dialog Window" SetText: radDialogWindow

                self Start: radChildWindow
                25 205 115 19 Move: radChildWindow
                Handle: Winfont SetFont: radChildWindow
                s" Child Window" SetText: radChildWindow

                self Start: chkChildState
                141 205 86 19 Move: chkChildState
                Handle: Winfont SetFont: chkChildState
                s" Initially hidden" SetText: chkChildState

                self Start: radMdiDialogWindow
                25 226 115 19 Move: radMdiDialogWindow
                Handle: Winfont SetFont: radMdiDialogWindow
                s" MDI Dialog Window" SetText: radMdiDialogWindow

                self Start: BtnEditFormCode
                149 143 72 15 Move: BtnEditFormCode
                Handle: Winfont SetFont: BtnEditFormCode
                s" to add Functions to Form" ToolString: BtnEditFormCode
                s" Add Words" SetText: BtnEditFormCode

                self Start: btnMenuBarFile
                208 109 18 14 Move: btnMenuBarFile
                Handle: Winfont SetFont: btnMenuBarFile
                s" ..." SetText: btnMenuBarFile

                self Start: TxtMenuBarFile
                100 108 100 16 Move: TxtMenuBarFile
                Handle: Winfont SetFont: TxtMenuBarFile

                ['] frmDefaultCommand SetCommand: self


                \ FormInitialized-Functions:
                
                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont

                \ FormDone-Function:
                
                On_Done: super
                ;M

;Object

: Start  ( -- )
                start: frmEditFormProperties
                 ;

' Start alias frmEditFormProperties-Start

: Stop  ( -- )
                close: frmEditFormProperties
                 ;

' Stop alias frmEditFormProperties-Stop



 \ Not executable: noop SetFunc: chkMenuBar

' AddFormFunction SetFunc: BtnEditFormCode

' noop SetFunc: btnMenuBarFile

 \ Not executable: noop SetFunc: TxtMenuBarFile

