\ frmFORMPAD.FRM
\ \- textbox 

needs excontrols.f


:Object frmFormPad                <Super DialogWindow

Font WinFont           \ default font
' 2drop value WmCommand-Func   \ function pointer for WM_COMMAND
ColorObject FrmColor      \ the background color 
150 175  2value XYPos  \ save screen location of form

\ Coordinates and dimensions for scnEditor
3  value scnEditorX
10  value scnEditorY
484  value scnEditorW
305  value scnEditorH
PushButton btnSaveToDisk
PushButton btnCompile
PushButton btnExit

:M ClassInit:   ( -- )
                ClassInit: super
                \ Insert your code here
                ;M

:M WindowStyle:  ( -- style )
                WS_POPUPWINDOW WS_DLGFRAME or 
                ;M

\ if this form is a modal form a non-zero parent must be set
:M ParentWindow:  ( -- hwndparent | 0 if no parent )
                hWndParent
                ;M

:M SetParentWindow:  ( hwndparent -- ) \ set owner window
                to hWndParent
                ;M

:M WindowTitle: ( -- ztitle )
                z" FormPad"
                ;M

:M StartSize:   ( -- width height )
                620 320 
                ;M

:M StartPos:    ( -- x y )
                XYPos
                ;M

:M Close:        ( -- )
                \ Insert your code here
                Close: super
                ;M

:M On_Init:     ( -- )
                s" MS Sans Serif" SetFaceName: WinFont
                8 Width: WinFont
                Create: WinFont 

                \ set form color to system color
                COLOR_BTNFACE Call GetSysColor NewColor: FrmColor


                self Start: btnSaveToDisk
                489 10 125 30 Move: btnSaveToDisk
                Handle: Winfont SetFont: btnSaveToDisk
                s" &Save to Disk" SetText: btnSaveToDisk

                self Start: btnCompile
                489 42 125 30 Move: btnCompile
                Handle: Winfont SetFont: btnCompile
                s" &Compile" SetText: btnCompile

                self Start: btnExit
                489 290 125 27 Move: btnExit
                Handle: Winfont SetFont: btnExit
                s" E&xit" SetText: btnExit

                ParentWindow: self   \ if this is a modal form disable parent
                if   0 ParentWindow: self Call EnableWindow drop then
                ;M

:M WM_COMMAND   ( h m w l -- res )
                over LOWORD ( ID ) self   \ object address on stack
                WMCommand-Func ?dup    \ must not be zero
                if        execute
                else        2drop   \ drop ID and object address
                then        0 ;M

:M SetCommand:  ( cfa -- )  \ set WMCommand function
                to WMCommand-Func
                ;M

:M On_Paint:    ( -- )
                0 0 GetSize: self Addr: FrmColor FillArea: dc
                ;M

:M On_Done:    ( -- )
                Delete: WinFont
                originx originy 2to XYPos
                ParentWindow: self   \ if modal form re-enable parent
                if   1 ParentWindow: self Call EnableWindow drop
                     \ reset focus to parent if we have one
                     ParentWindow: self Call SetFocus drop
                then
                \ Insert your code here
                On_Done: super
                ;M

;Object
